package handler

import (
	"github.com/gin-gonic/gin"
	"github.com/sirupsen/logrus"
	"youngee_b_api/consts"
	"youngee_b_api/model/http_model"
	"youngee_b_api/service"
	"youngee_b_api/util"
)

func WrapTasksketchlistHandler(ctx *gin.Context) {
	handler := newTasksketchlistHandler(ctx)
	baseRun(handler)
}

type Tasksketchlist struct {
	ctx  *gin.Context
	req  *http_model.TasksketchlistRequest
	resp *http_model.CommonResponse
}

func (c Tasksketchlist) getContext() *gin.Context {
	return c.ctx
}

func (c Tasksketchlist) getResponse() interface{} {
	return c.resp
}

func (c Tasksketchlist) getRequest() interface{} {
	return c.req
}

func (c Tasksketchlist) run() {
	data := http_model.TasksketchlistRequest{}
	data = *c.req
	res, err := service.Task.GetTasksketchlist(c.ctx, data)
	if err != nil {
		logrus.Errorf("[GetTasksketchList] call GetTasksketchList err:%+v\n", err)
		util.HandlerPackErrorResp(c.resp, consts.ErrorParamCheck, "")
		logrus.Info("GetTasksketchList fail,req:%+v", c.req)
		return
	}
	c.resp.Message = "成功查询初稿待审列表"
	c.resp.Data = res
	c.resp.Status = consts.ErrorSuccess
}

func (c Tasksketchlist) checkParam() error {
	return nil
}

func newTasksketchlistHandler(ctx *gin.Context) *Tasksketchlist {
	return &Tasksketchlist{
		ctx:  ctx,
		req:  http_model.NewTasksketchlistRequest(),
		resp: http_model.NewTasksketchlistResponse(),
	}
}
